#include<p18f4520.h>
#include<delays.h>

//command words
#define LD_CONFIG 0b00000000
#define LD_PROGM  0b00000010
#define LD_DATAM  0b00000011
#define ADD_INC   0b00000110
#define RD_PROGM  0b00000100
#define RD_DATAM  0b00000101
#define PROG_CY   0b00001000
#define BLK_ER_PROGM 0b00001001
#define BLK_ER_DATAM 0b00001011

//control pins
#define VDD   3
#define PGM   1
#define MCLR  2
#define DATA  0
#define CLOCK 4
#define CRTL_PORT LATD
#define CRTL_PORT_DIR TRISD

//functions
void Init_Ports(void);
void Enter_LVP(void);
void Send_Command(unsigned char command);
/*void Send_Data(unsigned int data);
unsigned int Read(unsigned char mem);//if mem=0;then program mem,if mem=1;then data mem
#define Inc_Add() Send_Command(ADD_INC);_delay_us(5)//tDLY2=1uS (ideally)
#define Begin_Prog() Send_Command(PROG_CY);_delay_ms(3)///tPROG=2.5ms 
#define Bulk_Erase_PGM Send_Command(BLK_ER_PROGM);_delay_ms(6) //tERA=6ms
#define Bulk_Erase_DM Send_Command(BLK_ER_DATAM);_delay_ms(6) //tERA=6ms
*/
void main(void)
{

	Init_Ports();
	Delay10KTCYx(10);
	//Enter_LVP();
	//_delay_ms(100);
	Send_Command(LD_PROGM);
	while(1);



}


void Init_Ports(void)
{
	CRTL_PORT_DIR&=~((1<<DATA)|(1<<CLOCK)|(1<<MCLR)|(1<<PGM)|(1<<VDD));//initalizing  all pins as o/p
	CRTL_PORT&=~((1<<DATA)|(1<<CLOCK)|(1<<MCLR)|(1<<PGM)|(1<<VDD));
}
/*void Enter_LVP(void)
{

CRTL_PORT|=(1<<VDD);
	_delay_ms(5);
CRTL_PORT|=(1<<PGM);
	_delay_ms(5);
CRTL_PORT|=(1<<MCLR);
	_delay_ms(5);
}*/

void Send_Command(unsigned char command)
{
	unsigned char i,temp=0;
	//setting DATA PIN as OUTPUT
	CRTL_PORT_DIR&=~(1<<DATA);
		
	for(i=0;i<6;i++)
	{	

		//~~~Changing Data~~~
		CRTL_PORT|=(1<<CLOCK);//clock=1
		temp=((command>>i) & 0x01);//on DATA(PD0) pin
		if(temp)
			CRTL_PORT|=(1<<0);
		else
			CRTL_PORT&=~(1<<0);
		Delay1TCY();
		CRTL_PORT&=~(1<<CLOCK);//clock=0
		Delay1TCY();


	}
}

/*void Send_Data(unsigned int data)
{
	unsigned char i,temp;
	//setting DATA PIN as OUTPUT
	CRTL_PORT_DIR&=~(1<<DATA);

	//Sendind Start Bit
	CRTL_PORT&=~(1<<DATA);	
	CRTL_PORT|=(1<<CLOCK);//clock=1
	_delay_us(1);
	CRTL_PORT&=~(1<<CLOCK);//clock=0
	_delay_us(1);



	for(i=0;i<14;i++)
	{
			//~~~Changing Data~~~
		CRTL_PORT|=(1<<CLOCK);//clock=1
		temp=(unsigned char)((data>>i) & 0x0001);//on DATA(PD0) pin
		if(temp)
			CRTL_PORT|=(1<<0);
		else
			CRTL_PORT&=~(1<<0);
		_delay_us(1);
		CRTL_PORT&=~(1<<CLOCK);//clock=0
		_delay_us(1);	
	}

	//Sending Stop bit
	CRTL_PORT&=~(1<<DATA);
	CRTL_PORT|=(1<<CLOCK);//clock=1
	_delay_us(1);
	CRTL_PORT&=~(1<<CLOCK);//clock=0
	_delay_us(1);


}

unsigned int Read(unsigned char mem)
{
	unsigned char i;
	unsigned int data=0,temp;

	//setting DATA PIN as OUTPUT
	CRTL_PORT_DIR&=~(1<<DATA);


	if(mem==0)
		Send_Command(RD_PROGM);
	else
		Send_Command(RD_DATAM);

	//setting DATA PIN as INPUT
	CRTL_PORT_DIR|=(1<<DATA);
	
	for(i=0;i<16;i++)
	{

		CRTL_PORT|=(1<<CLOCK);//clock=1
		_delay_us(1);
		CRTL_PORT&=~(1<<CLOCK);//clock=0
		data=data|((unsigned int)(CRTL_PORT & 0x01)); //Read data from PD0 pin
		data=data<<1;
		_delay_us(1);
	}
	
	data&=~((1<<15)|(1<<0));//zeroing 15th bit(start) and 0th bit(bit)
	
	//sending data in format MSB--LSB 
	temp=(data & 0xff00)>>8;
	data=data<<8;
	data=data|temp;
	return(data);
	
}*/

